From cfff0dba40f0a82e56d3670d57c2a0bc639e4b46 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 03:38:34 +0000
Subject: [PATCH 16/17] Update documentation.


  - fix typos.
  - minor fix on anitya tests.
  - create method to save project analysis on Monitor.

---

diff --git a/alembic/versions/0920061a363d_rename_package_table_to_project.py b/alembic/versions/0920061a363d_rename_package_table_to_project.py
new file mode 100644
index 0000000..335101d
--- /dev/null
+++ b/alembic/versions/0920061a363d_rename_package_table_to_project.py
@@ -0,0 +1,25 @@
+"""rename package table to project.
+
+Revision ID: 0920061a363d
+Revises: cc4887b7c3da
+Create Date: 2018-03-13 17:48:05.506903
+
+"""
+from alembic import op
+import sqlalchemy as sa
+
+
+# revision identifiers, used by Alembic.
+revision = '0920061a363d'
+down_revision = 'cc4887b7c3da'
+branch_labels = None
+depends_on = None
+
+
+def upgrade():
+    op.rename_table('packages', 'projects')
+    op.alter_column('versions', 'package_id', new_column_name='project_id')
+
+
+def downgrade():
+    op.rename_table('projects', 'packages')
diff --git a/kiskadee/api/app.py b/kiskadee/api/app.py
index eae5017..3714c17 100644
--- a/kiskadee/api/app.py
+++ b/kiskadee/api/app.py
@@ -26,27 +26,27 @@ def index():
         return jsonify({'fetchers': result.data})
 
 
-@kiskadee.route('/packages')
-def packages():
-    """Get the list of analyzed packages."""
+@kiskadee.route('/projects')
+def projects():
+    """Get the list of analyzed projects."""
     if request.method == 'GET':
-        packages = db.session.query(Project).all()
-        package_schema = ProjectSchema(
+        projects = db.session.query(Project).all()
+        project_schema = ProjectSchema(
             many=True,
-            exclude=['versions.analysis', 'versions.package_id']
+            exclude=['versions.analysis', 'versions.project_id']
         )
-        data, errors = package_schema.dump(packages)
-        return jsonify({'packages': data})
+        data, errors = project_schema.dump(projects)
+        return jsonify({'projects': data})
 
 
-@kiskadee.route('/analysis/<pkg_name>/<version>', methods=['GET'])
-def package_analysis_overview(pkg_name, version):
-    """Get a analysis list of some package version."""
+@kiskadee.route('/analysis/<project_name>/<version>', methods=['GET'])
+def project_analysis_overview(project_name, version):
+    """Get a analysis list of some project version."""
 
-    #TODO: This can be a simple inner join between package, version and analysis
-    _package_id = db.filter_by_name(Project, pkg_name).id
+    #TODO: This can be a simple inner join between project, version and analysis
+    _project_id = db.filter_by_name(Project, project_name).id
     version_id = db.session.query(Version)\
-            .filter_by(number = version, package_id = _package_id ).first().id
+            .filter_by(number = version, project_id = _project_id ).first().id
     analysis = (
             db.session.query(Analysis)
             .options(
diff --git a/kiskadee/model.py b/kiskadee/model.py
index 83302b9..2e861df 100644
--- a/kiskadee/model.py
+++ b/kiskadee/model.py
@@ -139,7 +139,9 @@ class Analysis(Base):
                               uselist=False, back_populates='analysis')
 
     @staticmethod
-    def save(db, data, analyzer, result, version):
+    def save(db, analyzer, result, project):
+        version = project.versions[-1]
+        name = project.name
         _analysis = kiskadee.model.Analysis()
         try:
             _analyzer = db.session.query(kiskadee.model.Analyzer).\
@@ -153,10 +155,10 @@ class Analysis(Base):
                     'results': _analysis.raw['results'],
                     'id': _analysis.id
                 }
-            Report.save(db, dict_analysis, data, _analyzer.name)
+            Report.save(db, dict_analysis, _analyzer.name, name)
             kiskadee.logger.debug(
                     "MONITOR: Saved analysis done by {} for project: {}-{}"
-                    .format(analyzer, data["name"], data["version"])
+                    .format(analyzer, name, version.number)
                 )
             return
         except Exception as err:
@@ -184,7 +186,7 @@ class Report(Base):
     analysis = orm.relationship('Analysis', back_populates='report')
 
     @staticmethod
-    def save(db, analysis, data, analyzer_name):
+    def save(db, analysis, analyzer_name, project_name):
         try:
             results = analysis['results']
             analyzer_report = Report.REPORTERS[analyzer_name](results)
@@ -198,7 +200,7 @@ class Report(Base):
             db.session.commit()
             kiskadee.logger.debug(
                     "MONITOR: Saved analysis reports for {} project"
-                    .format(data["name"])
+                    .format(project_name)
                 )
         except KeyError as key:
             kiskadee.logger.debug(
@@ -209,7 +211,7 @@ class Report(Base):
         except Exception as err:
             kiskadee.logger.debug(
                     "MONITOR: Failed to get analysis reports to {} project"
-                    .format(data["name"])
+                    .format(project_name)
                 )
             kiskadee.logger.debug(err)
         return
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index d88a085..710127a 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -23,10 +23,14 @@ class Monitor:
         Analyzer.create_analyzers(self.db)
 
     def run(self):
+        """Run Monitor process. This method resumes Monitor behavior. It dequeue
+        projects from fetchers, check if the project is valid and if so send it
+        to Runner. When Runner ends a analysis, the Monitor dequeue the analysis
+        and save it on database. """
         kiskadee.logger.debug('MONITOR PID: {}'.format(os.getpid()))
 
         for fetcher in kiskadee.load_fetchers():
-            thread = Monitor._start_fetcher(fetcher.Fetcher().watch)
+            thread = Monitor.start_fetcher(fetcher.Fetcher().watch)
 
         while RUNNING:
             kiskadee.logger.debug('MONITOR STATE: Idle'.format(os.getpid()))
@@ -47,7 +51,7 @@ class Monitor:
             data["fetcher_id"] = fetcher.id if fetcher else ''
             if not self.is_a_new_project_version(project, data):
                 kiskadee.logger.debug('MONITOR STATE: Project {} already'\
-                        'analyzed'.format(data['name']))
+                        ' analyzed'.format(data['name']))
                 return
             self.queues.enqueue_analysis(data)
 
@@ -74,15 +78,18 @@ class Monitor:
         project = self.db.filter_by_name(Project, data['name'])
         if not project:
             project = Project.save(self.db, data)
-        if project:
+        else:
             project = Project.update(self.db, project, data)
+        self.save_project_analysis(data, project)
 
+    def save_project_analysis(self, data, project):
         for analyzer, result in data['results'].items():
-            Analysis.save(self.db, data, analyzer, result, project.versions[-1])
+            Analysis.save(self.db, analyzer, result, project)
 
 
     @staticmethod
-    def _start_fetcher(module, joinable=False, timeout=None):
+    def start_fetcher(module, joinable=False, timeout=None):
+        """Start a fetcher as a thread of the Monitor process."""
         module_as_a_thread = threading.Thread(target=module)
         module_as_a_thread.daemon = True
         module_as_a_thread.start()
diff --git a/kiskadee/queue.py b/kiskadee/queue.py
index bbb7128..0d4956f 100644
--- a/kiskadee/queue.py
+++ b/kiskadee/queue.py
@@ -55,12 +55,13 @@ class Queues():
         return result
 
     @staticmethod
-    def enqueue_project(project, fetcher):
+    def enqueue_project(project, fetcher=None):
         """Put a result on the results queue."""
-        kiskadee.logger.debug(
-                "FETCHER {}: sending package {}-{} for monitor"
-                .format(fetcher, project['name'], project['version'])
-            )
+        if fetcher:
+            kiskadee.logger.debug(
+                    "FETCHER {}: sending package {}-{} for monitor"
+                    .format(fetcher, project['name'], project['version'])
+                )
         projects.put(project)
 
     @staticmethod
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index d1fa040..e245552 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -27,7 +27,7 @@ class Runner:
 
         Continuously dequeue projects from `analyses_queue` and call the
         :func:`analyze` method, passing the dequeued project as argument.
-        After the analysis, send the result back to monitor.
+        After the analysis, send the result back to Monitor.
         """
         kiskadee.logger.debug('RUNNER PID: {}'.format(os.getpid()))
         while RUNNING:
@@ -89,7 +89,7 @@ class Runner:
         The `analyzer` is the name of a static analyzer already created on the
         database.
         The `source_path` is the directory to a uncompressed source, returned
-        by the :func:`_path_to_uncompressed_source`.
+        by the :func:`get_project_code_path`.
         """
         if source_path is None:
             return None
@@ -112,7 +112,8 @@ class Runner:
             return None
 
     def get_project_code_path(self):
-
+        """ Returns a string, representing the path of the uncompressed
+        project source."""
         if not (self.fetcher and self.project):
             return None
 
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index f4acf72..1017889 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -44,8 +44,8 @@ class MonitorTestCase(unittest.TestCase):
         self.assertEqual(monitored_project['version'], '0.1')
 
     def test_run_fetchers_as_threads(self):
-        Monitor._start_fetcher(self.example_fetcher.watch)
-        Monitor._start_fetcher(self.example_fetcher.watch)
+        Monitor.start_fetcher(self.example_fetcher.watch)
+        Monitor.start_fetcher(self.example_fetcher.watch)
         first_monitored_project = self.monitor.dequeue_project_from_fetchers()
         second_monitored_project = self.monitor.dequeue_project_from_fetchers()
         self.assertIn("version", first_monitored_project)
diff --git a/kiskadee/tests/plugins/test_plugins.py b/kiskadee/tests/plugins/test_plugins.py
index 9fe8262..d9f532d 100644
--- a/kiskadee/tests/plugins/test_plugins.py
+++ b/kiskadee/tests/plugins/test_plugins.py
@@ -180,13 +180,15 @@ class TestAnityaFetcher(unittest.TestCase):
 
     def test_get_sources(self):
 
-        def mock_github(self, source_data, path):
+        def mock_github(self, fetcher, source_data, path):
             return 'kiskadee/tests/test_source/Sources.gz'
 
         kiskadee.fetchers.anitya.Backends.github = mock_github
         source_data = {'meta': {'backend': 'GitHub'}}
         source_path = self.anitya_fetcher.get_sources(source_data)
-        self.assertEqual(source_path, mock_github("self", "foo", "bla"))
+        self.assertEqual(source_path, mock_github(
+            "self", "example", "foo", "bla")
+            )
 
     def test_create_package_dict(self):
 
diff --git a/kiskadee/tests/units/test_model.py b/kiskadee/tests/units/test_model.py
index b0aafa7..6fda0be 100644
--- a/kiskadee/tests/units/test_model.py
+++ b/kiskadee/tests/units/test_model.py
@@ -14,16 +14,16 @@ class ModelTestCase(unittest.TestCase):
 
     def setUp(self):
         kiskadee.tests.clean_test_db(self.db, model.Base.metadata)
-        self.package = model.Project(name='python-kiskadee')
+        self.project = model.Project(name='python-kiskadee')
         self.version = model.Version(number='1.0-rc1')
         self.fetcher = model.Fetcher(
               name='kiskadee-fetcher', target='university'
             )
         self.db.session.add(self.fetcher)
         self.db.session.commit()
-        self.fetcher.packages.append(self.package)
-        self.package.versions.append(self.version)
-        self.db.session.add(self.package)
+        self.fetcher.projects.append(self.project)
+        self.project.versions.append(self.version)
+        self.db.session.add(self.project)
         self.db.session.add(self.fetcher)
         self.db.session.add(self.version)
 
@@ -43,9 +43,9 @@ class ModelTestCase(unittest.TestCase):
         fetchers = self.db.session.query(model.Fetcher).all()
         self.assertEqual(fetchers, [self.fetcher])
 
-    def test_query_package(self):
-        packages = self.db.session.query(model.Project).all()
-        self.assertEqual(packages, [self.package])
+    def test_query_project(self):
+        projects = self.db.session.query(model.Project).all()
+        self.assertEqual(projects, [self.project])
 
     def test_query_version(self):
         versions = self.db.session.query(model.Version).all()
@@ -62,7 +62,7 @@ class ModelTestCase(unittest.TestCase):
         fetchers = self.db.session.query(model.Fetcher).all()
         self.assertEqual(len(fetchers), 2)
 
-    def test_add_version_without_package(self):
+    def test_add_version_without_project(self):
         version = model.Version(number='3.1')
         self.db.session.add(version)
         with self.assertRaises(exc.IntegrityError):
@@ -75,51 +75,51 @@ class ModelTestCase(unittest.TestCase):
         with self.assertRaises(exc.IntegrityError):
             self.db.session.commit()
 
-    def test_add_package_without_fetcher(self):
-        package = model.Project(name='foo-bar')
-        self.db.session.add(package)
+    def test_add_project_without_fetcher(self):
+        project = model.Project(name='foo-bar')
+        self.db.session.add(project)
         with self.assertRaises(exc.IntegrityError):
             self.db.session.commit()
 
-    def test_unique_package_in_fetcher(self):
-        package_1 = model.Project(name='foo-bar')
-        package_2 = model.Project(name='foo-bar')
-        self.fetcher.packages.append(package_1)
-        self.fetcher.packages.append(package_2)
+    def test_unique_project_in_fetcher(self):
+        project_1 = model.Project(name='foo-bar')
+        project_2 = model.Project(name='foo-bar')
+        self.fetcher.projects.append(project_1)
+        self.fetcher.projects.append(project_2)
         with self.assertRaises(exc.IntegrityError):
             self.db.session.commit()
 
-    def test_unique_version_for_package(self):
-        package_version_1 = model.Version(number='1.0')
-        package_version_2 = model.Version(number='1.0')
-        self.package.versions.append(package_version_1)
-        self.package.versions.append(package_version_2)
+    def test_unique_version_for_project(self):
+        project_version_1 = model.Version(number='1.0')
+        project_version_2 = model.Version(number='1.0')
+        self.project.versions.append(project_version_1)
+        self.project.versions.append(project_version_2)
         with self.assertRaises(exc.IntegrityError):
             self.db.session.commit()
 
     def test_compose_kiskadee_source(self):
         _analyzer = self.db.session.query(model.Analyzer)\
                     .filter(model.Analyzer.name == "cppcheck").first()
-        package = model.Project(
+        project = model.Project(
                 name='bla',
                 fetcher_id=self.fetcher.id
                 )
-        package_version = model.Version(
+        project_version = model.Version(
                 number='1.0.1',
-                package_id=package.id
+                project_id=project.id
                 )
 
-        package_analysis = model.Analysis(
+        project_analysis = model.Analysis(
                 raw="<>",
                 analyzer_id=_analyzer.id,
-                version_id=package_version.id
+                version_id=project_version.id
                 )
 
-        self.fetcher.packages.append(package)
-        package.versions.append(package_version)
-        package_version.analysis.append(package_analysis)
+        self.fetcher.projects.append(project)
+        project.versions.append(project_version)
+        project_version.analysis.append(project_analysis)
 
-        self.assertEqual(package.versions[0].analysis[0].raw, "<>")
+        self.assertEqual(project.versions[0].analysis[0].raw, "<>")
 
     def test_save_several_analysis(self):
 
@@ -132,42 +132,42 @@ class ModelTestCase(unittest.TestCase):
                 .filter(model.Analyzer.name == "flawfinder").first()
                 )
 
-        package = model.Project(
+        project = model.Project(
                 name='bla',
                 fetcher_id=self.fetcher.id
                 )
-        package_version = model.Version(
+        project_version = model.Version(
                 number='1.0.1',
-                package_id=package.id
+                project_id=project.id
                 )
 
-        self.fetcher.packages.append(package)
-        package.versions.append(package_version)
+        self.fetcher.projects.append(project)
+        project.versions.append(project_version)
 
-        self.db.session.add(package)
-        self.db.session.add(package_version)
+        self.db.session.add(project)
+        self.db.session.add(project_version)
         self.db.session.commit()
 
-        package_analysis1 = model.Analysis(
+        project_analysis1 = model.Analysis(
                 raw="<>",
                 analyzer_id=_analyzer1.id,
-                version_id=package_version.id
+                version_id=project_version.id
                 )
-        package_analysis2 = model.Analysis(
+        project_analysis2 = model.Analysis(
                 raw="><",
                 analyzer_id=_analyzer2.id,
-                version_id=package_version.id
+                version_id=project_version.id
                 )
 
-        self.db.session.add(package_analysis1)
-        self.db.session.add(package_analysis2)
+        self.db.session.add(project_analysis1)
+        self.db.session.add(project_analysis2)
         self.db.session.commit()
 
-        saved_package = (
+        saved_project = (
                 self.db.session.query(model.Project)
                 .filter(model.Project.name == 'bla').first()
                 )
-        analysis = saved_package.versions[-1].analysis
+        analysis = saved_project.versions[-1].analysis
         self.assertEqual(len(analysis), 2)
         self.assertEqual(analysis[0].raw, "<>")
         self.assertEqual(analysis[1].raw, "><")

